/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-json-prolog-msgs-0.0.5-0quantal-20150425-1619/srv/PrologNextSolution.srv
 *
 */


#ifndef JSON_PROLOG_MSGS_MESSAGE_PROLOGNEXTSOLUTIONRESPONSE_H
#define JSON_PROLOG_MSGS_MESSAGE_PROLOGNEXTSOLUTIONRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace json_prolog_msgs
{
template <class ContainerAllocator>
struct PrologNextSolutionResponse_
{
  typedef PrologNextSolutionResponse_<ContainerAllocator> Type;

  PrologNextSolutionResponse_()
    : status(0)
    , solution()  {
    }
  PrologNextSolutionResponse_(const ContainerAllocator& _alloc)
    : status(0)
    , solution(_alloc)  {
    }



   typedef int8_t _status_type;
  _status_type status;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _solution_type;
  _solution_type solution;


    enum { NO_SOLUTION = 0 };
     enum { WRONG_ID = 1 };
     enum { QUERY_FAILED = 2 };
     enum { OK = 3 };
 

  typedef boost::shared_ptr< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PrologNextSolutionResponse_

typedef ::json_prolog_msgs::PrologNextSolutionResponse_<std::allocator<void> > PrologNextSolutionResponse;

typedef boost::shared_ptr< ::json_prolog_msgs::PrologNextSolutionResponse > PrologNextSolutionResponsePtr;
typedef boost::shared_ptr< ::json_prolog_msgs::PrologNextSolutionResponse const> PrologNextSolutionResponseConstPtr;

// constants requiring out of line definition

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace json_prolog_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "13aa54b7380a45414b5c48869ecbe7c8";
  }

  static const char* value(const ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x13aa54b7380a4541ULL;
  static const uint64_t static_value2 = 0x4b5c48869ecbe7c8ULL;
};

template<class ContainerAllocator>
struct DataType< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "json_prolog_msgs/PrologNextSolutionResponse";
  }

  static const char* value(const ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "byte NO_SOLUTION = 0\n\
byte WRONG_ID = 1\n\
byte QUERY_FAILED = 2\n\
byte OK = 3\n\
\n\
byte status\n\
string solution\n\
\n\
";
  }

  static const char* value(const ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.status);
      stream.next(m.solution);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PrologNextSolutionResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::json_prolog_msgs::PrologNextSolutionResponse_<ContainerAllocator>& v)
  {
    s << indent << "status: ";
    Printer<int8_t>::stream(s, indent + "  ", v.status);
    s << indent << "solution: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.solution);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSON_PROLOG_MSGS_MESSAGE_PROLOGNEXTSOLUTIONRESPONSE_H
