/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-json-prolog-msgs-0.0.5-0quantal-20150425-1619/srv/PrologQuery.srv
 *
 */


#ifndef JSON_PROLOG_MSGS_MESSAGE_PROLOGQUERYREQUEST_H
#define JSON_PROLOG_MSGS_MESSAGE_PROLOGQUERYREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace json_prolog_msgs
{
template <class ContainerAllocator>
struct PrologQueryRequest_
{
  typedef PrologQueryRequest_<ContainerAllocator> Type;

  PrologQueryRequest_()
    : mode(0)
    , id()
    , query()  {
    }
  PrologQueryRequest_(const ContainerAllocator& _alloc)
    : mode(0)
    , id(_alloc)
    , query(_alloc)  {
    }



   typedef int8_t _mode_type;
  _mode_type mode;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _id_type;
  _id_type id;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _query_type;
  _query_type query;


    enum { ALL_SOLUTIONS = 0 };
     enum { INCREMENTAL = 1 };
 

  typedef boost::shared_ptr< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PrologQueryRequest_

typedef ::json_prolog_msgs::PrologQueryRequest_<std::allocator<void> > PrologQueryRequest;

typedef boost::shared_ptr< ::json_prolog_msgs::PrologQueryRequest > PrologQueryRequestPtr;
typedef boost::shared_ptr< ::json_prolog_msgs::PrologQueryRequest const> PrologQueryRequestConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace json_prolog_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ae1d940ff32be0f4c9af16fc85baab7a";
  }

  static const char* value(const ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xae1d940ff32be0f4ULL;
  static const uint64_t static_value2 = 0xc9af16fc85baab7aULL;
};

template<class ContainerAllocator>
struct DataType< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "json_prolog_msgs/PrologQueryRequest";
  }

  static const char* value(const ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
\n\
\n\
\n\
\n\
\n\
\n\
byte ALL_SOLUTIONS=0\n\
byte INCREMENTAL=1\n\
\n\
byte mode\n\
string id\n\
string query\n\
";
  }

  static const char* value(const ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.mode);
      stream.next(m.id);
      stream.next(m.query);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PrologQueryRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::json_prolog_msgs::PrologQueryRequest_<ContainerAllocator>& v)
  {
    s << indent << "mode: ";
    Printer<int8_t>::stream(s, indent + "  ", v.mode);
    s << indent << "id: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.id);
    s << indent << "query: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.query);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSON_PROLOG_MSGS_MESSAGE_PROLOGQUERYREQUEST_H
